<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
          "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html>
  <!-- Copyright 2008 Google Inc.  All rights reserved. -->
  <head>
    <title>NPAPI Bridge RPC Performance Tests</title>
    <script type="text/javascript">
      <!--
var nacl = null;
var loadTimer = null;
var BenchSteps = 10000;
var RunBenchmark = function() {
  var context = this.context;
  var steps = BenchSteps;
  var point_function = this.point_function;
  var output = document.getElementById('LogOutput');  // this.output;
  var call_time = 0;
  var worst_time = 0;
  for (var i = 0; i < steps; i++) {
    var before_call = new Date();
    var arr = point_function();
    var after_call = new Date();
    var difftime = after_call.getTime() - before_call.getTime();
    call_time = call_time + difftime;
    if (difftime > worst_time) {
      worst_time = difftime
    }
  }
  output.innerHTML += this.type + ": " + call_time + ' ms (' + (call_time / steps) + ' per call; worst ' + worst_time + ')<BR>\n';
}

var Benchmark = function(type, point_function) {
  this.type = type;
  this.point_function = point_function;
  this.output = document.getElementById(type + 'Output');
  this.Run = RunBenchmark;
}

var BenchIntTest;
var BenchStringTest;
var BenchBigStringTest;
var BenchNullTest;
var BenchNullNpapiTest;
var BenchRPC3x;
var OneKString =
  "0123456789abcdef0123456789abcdef0123456789abcdef0123456789abcdef" +
  "0123456789abcdef0123456789abcdef0123456789abcdef0123456789abcdef" +
  "0123456789abcdef0123456789abcdef0123456789abcdef0123456789abcdef" +
  "0123456789abcdef0123456789abcdef0123456789abcdef0123456789abcdef" +
  "0123456789abcdef0123456789abcdef0123456789abcdef0123456789abcdef" +
  "0123456789abcdef0123456789abcdef0123456789abcdef0123456789abcdef" +
  "0123456789abcdef0123456789abcdef0123456789abcdef0123456789abcdef" +
  "0123456789abcdef0123456789abcdef0123456789abcdef0123456789abcdef" +
  "0123456789abcdef0123456789abcdef0123456789abcdef0123456789abcdef" +
  "0123456789abcdef0123456789abcdef0123456789abcdef0123456789abcdef" +
  "0123456789abcdef0123456789abcdef0123456789abcdef0123456789abcdef" +
  "0123456789abcdef0123456789abcdef0123456789abcdef0123456789abcdef" +
  "0123456789abcdef0123456789abcdef0123456789abcdef0123456789abcdef" +
  "0123456789abcdef0123456789abcdef0123456789abcdef0123456789abcdef" +
  "0123456789abcdef0123456789abcdef0123456789abcdef0123456789abcdef" +
  "0123456789abcdef0123456789abcdef0123456789abcdef0123456789abcdef";

var PostInit = function() {
  if (nacl == undefined) {
    alert('Unable to load, try reloading page (or missing plugins?)');
    return;
  }
  if (nacl.nullMethod == undefined) {
    loadTimer = setTimeout(PostInit, 100);
  } else {
    // when nacl becomes available, enable control buttons
    document.getElementById('button_int_test').disabled = null;
    document.getElementById('button_string_test').disabled = null;
    document.getElementById('button_big_string_test').disabled = null;
    document.getElementById('button_null_rpc_test').disabled = null;

    var log = document.getElementById('LogOutput');
    log.innerHTML += "Using " + BenchSteps + " iterations for each test<BR>\n";
  }
}

function doOnLoad() {
  nacl = document.getElementById('nacl');
  PostInit();
}

function doOnUnload() {
  clearTimeout(loadTimer);
}
      -->
    </script>
  </head>
  <body onload="doOnLoad();" onunload="doOnUnload();">
    <h1>Timed NPAPI Bridge Demo </h1>
    <embed id="nacl" src="npapi_test" type="application/x-nacl-npapi"
           width="0" height="0" />
    <script type="application/x-javascript">
      <!--
var nacl = document.getElementById('nacl');
// Create a NativeClient version of the benchmark.
var IntTestNativeClient = function() {
  return nacl.nullMethod(0);
}
BenchIntTest = new Benchmark('IntTest', IntTestNativeClient);
var StringTestNativeClient = function() {
  return nacl.nullMethod("hello world");
}
BenchStringTest = new Benchmark('StringTest', StringTestNativeClient);
var BigStringTestNativeClient = function() {
  return nacl.nullMethod(OneKString);
}
BenchBigStringTest = new Benchmark('BigStringTest', BigStringTestNativeClient);
var NullTestNativeClient = function() {
  return nacl.nullMethod();
}
BenchNullTest = new Benchmark('NullTest', NullTestNativeClient);
      -->
    </script>
    <table summary="A collection of buttons to invoke tests">
      <thead>
        <tr>
          <td align=center>
            <input type="button" onclick="BenchIntTest.Run()"
                   id="button_int_test" value="IntTest"
                   disabled="true" />
          </td>
          <td align=center>
            <input type="button" onclick="BenchStringTest.Run()"
                   id="button_string_test" value="StringTest"
                   disabled="true" />
          <td align=center>
            <input type="button" onclick="BenchBigStringTest.Run()"
                   id="button_big_string_test" value="BigStringTest"
                   disabled="true" />
          </td>
          <td align=center>
            <input type="button" onclick="BenchNullTest.Run()"
                   id="button_null_rpc_test" value="NullRpcTest"
                   disabled="true" />
          </td>
        </tr>
      </thead>
    </table>
    <h2>Click the above button to run the benchmark.</h2>
    <table summary="A box containing execution logging output">
      <tr>
        <td id="LogOutput"></td>
      </tr>
    </table>
  </body>
</html>
